﻿package classes.common
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import classes.common.BaseStage;
	import classes.common.BaseButton;
	import classes.common.Static_Value;
	import classes.common.Item;
	
	public class CommonFunction
	{
		//--------------------------------------------------------------------------
		//  Method:CommonFunction
		//  Expranation: Constructor
		//	Parameter:  
		//--------------------------------------------------------------------------	
		public function CommonFunction()
		{

		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		
		//--------------------------------------------------------------------------
		//  Method:set_Image_button
		//  Expranation: Setting for Instruction Button
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		public function set_Image_button(objBtn:BaseButton,strName:String,pos_X:Number
										  ,pos_Y:Number,fnc_Click:Function,objAddParent:Object):void 
		{
			objBtn.x = pos_X;
			objBtn.y = pos_Y;
			objBtn.name = strName;
			objBtn.removeEventListener(MouseEvent.CLICK,fnc_Click);
			objBtn.addEventListener(MouseEvent.CLICK,fnc_Click);
			objAddParent.addChild(objBtn);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setVocSetion
		//  Expranation: Set Gallery objects
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------
		public function setVocSetion(objBase:BaseStage,objPic:Object,strPicName:String
									  ,objSound:Object,objLoadCls_Exercise:Object,objLoadCls_Quiz:Object):void
		{
			//** set Background pic **//	
			var numPos_X:Number = Static_Value.VOC_BACK_PIC_BASE_X;
			var numPos_Y:Number = Static_Value.VOC_BACK_PIC_BASE_Y;
			var objItem:Item = new Item(objBase.sprMain,objBase.sprExercise);
			objItem.setDisplayItem(objPic,strPicName,objSound,"Sound_" + strPicName,"",numPos_X,numPos_Y,true,null,true);
			objItem.addContainerItems(MouseEvent.CLICK,objItem.mouseClickEventHandler_Playsound);
	
			//** set Buttons **//
			var obBtn:BaseButton;
			numPos_X = Static_Value.VOC_BTN_BASE_X;
			numPos_Y = Static_Value.VOC_BTN_BASE_Y;
			//* Exercise *//
			obBtn = new BaseButton("Btn_Exercise");
			obBtn.imageButton("image/vocabulary/buttons/Exercise.png",1.0);
			set_Image_button(obBtn,"Btn_Exercise",numPos_X
							 ,numPos_Y,mouseClick_VocSetion(objBase,objLoadCls_Exercise),objBase.sprExercise);			
			//* Quiz *//
			obBtn = new BaseButton("Btn_Quiz");
			obBtn.imageButton("image/vocabulary/buttons/Quiz.png",1.0);
			set_Image_button(obBtn,"Btn_Quiz",numPos_X
							 ,numPos_Y + Static_Value.VOC_BTN_DIS_Y,mouseClick_VocSetion(objBase,objLoadCls_Quiz),objBase.sprExercise);							 
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouseClick　event
		//	Parameter: 	objBase		:BaseStage	--- Base Stage
		//				objParent	:Object	--- parent object
		//				objLoadCls	:Object	--- Loading Class object		
		//--------------------------------------------------------------------------
		private function mouseClick_VocSetion(objBase:BaseStage,objLoadCls:Object):Function{
			return function(event:Event):void{			
				if(objLoadCls!=null)
				{
					//-- Create New class object --//
					var objRequestCls = new objLoadCls();
					//objRequestCls.name = strLoadCls;
					if(objBase!=null)
					{	//-- Base sprExercise and menubar rewrite --//
						while(objBase.sprExercise.numChildren > 0){
							objBase.sprExercise.removeChildAt(0);  
						}
						objBase.sprExercise.addChild(objRequestCls);
						//-- Initialize of new class object --//
						objRequestCls.objBase = objBase;					
						objRequestCls.init();
					}else
					{
						trace("Section:objBase==null");
					}
				}
			}
		}		

		//--------------------------------------------------------------------------
		//  Method:set_Instruction_button
		//  Expranation: Setting for Instruction Button
		//	Parameter: 	objParent	:Object	--- Parent Object 
		//			 	pos_X		:Number	--- Button X position
		//			 	pos_Y		:Number	--- Button Y position
		//			 	objMov		:Object	--- Display object after click
		//--------------------------------------------------------------------------	
		public function set_Instruction_button(objBase:BaseStage,objParent:Object,strImgURL:String
											   ,strInstName:String,pos_X:Number,pos_Y:Number
											   ,objMov:Object):void 
		{
			var objBtn:BaseButton = new BaseButton(Static_Value.INST_BUTTON_NAME);
			objBtn.imageButton(strImgURL,1.0);
			objBtn.x = pos_X;
			objBtn.y = pos_Y;
			objBtn.name = "Btn_" + Static_Value.INST_BUTTON_NAME;
			objBtn.removeEventListener(MouseEvent.CLICK,mouseClick_Inst(objBase,objMov,strInstName));
			objBtn.addEventListener(MouseEvent.CLICK,mouseClick_Inst(objBase,objMov,strInstName));
			//sprParent.addChild(btnPrevious);
			objParent.addChild(objBtn);
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClick_Inst
		//  Expranation: mouseClick　event
		//	Parameter: 	objBase	:BaseStage	--- BaseStage
		//			 	objVal	:Object	--- Insruction object after click
		//--------------------------------------------------------------------------
		private function mouseClick_Inst(objBase:BaseStage,objVal:Object,strInstName:String):Function{
			return function(event:Event):void{
				var blnExist = false;
				for(var i:int=0;i<objBase.sprMain.numChildren; i++)
				{
					//trace(objBase.sprMain.getChildAt(i).name);
					if(objBase.sprMain.getChildAt(i).name.indexOf(strInstName)!=-1)
					{
						objBase.sprMain.getChildAt(i).visible = true;
						var objMov = objBase.sprMain.getChildAt(i);
						objBase.sprMain.setChildIndex(objMov,objBase.sprMain.numChildren-1);	//move front
						//objMov.rewind;
						objMov.gotoAndPlay(0);
						blnExist = true;
						break;
					}  
				}
				if(!blnExist)
				{
					var objIns = new objVal;
					objIns.name = strInstName;
					//Button Back
					var btn_Retn:BaseButton = new BaseButton(Static_Value.RETURN_BUTTON_NAME);
					btn_Retn.imageButton(Static_Value.RETURN_BUTTON_IMAGE,1.0);
					btn_Retn.x = Static_Value.RETURN_BUTTON_BASE_X;
					btn_Retn.y = Static_Value.RETURN_BUTTON_BASE_Y;
					btn_Retn.name = Static_Value.RETURN_BUTTON_NAME;
					btn_Retn.removeEventListener(MouseEvent.CLICK,mouseClick_Retn(objBase));
					btn_Retn.addEventListener(MouseEvent.CLICK,mouseClick_Retn(objBase));
					objIns.addChild(btn_Retn);				
					objBase.sprMain.addChild(objIns);
				}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClick_Retn
		//  Expranation: mouseClick　event
		//	Parameter: 	objVal	:Object	--- Move to new puzzle after click
		//--------------------------------------------------------------------------
		private function mouseClick_Retn(objBase:BaseStage):Function{
			return function(event:Event):void{
				for(var i:int=0;i<objBase.sprMain.numChildren; i++)
				{
					//trace(objBase.sprMain.getChildAt(i).name);
					if(objBase.sprMain.getChildAt(i).name.indexOf(Static_Value.INSTRACTOR_NAME)!=-1)
					{
						objBase.sprMain.getChildAt(i).visible = false;
						var objMov = objBase.sprMain.getChildAt(i);
						objMov.stop();
						break;
					}  
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:set_SubTitle
		//  Expranation: Setting for Instruction Button
		//	Parameter: 	objParent	:Object	--- Parent Object 
		//			 	strImgURL	:String	--- Image URL
		//			 	strName		:String	--- Name		
		//			 	pos_X		:Number	--- Button X position
		//			 	pos_Y		:Number	--- Button Y position
		//--------------------------------------------------------------------------	
		public function set_SubTitle(objParent:Object,strImgURL:String,strName:String
									 ,pos_X:Number,pos_Y:Number):void 
		{
			var objBtn:BaseButton = new BaseButton(strName);
			objBtn.imageButton(strImgURL,1.0,false);
			objBtn.x = pos_X;
			objBtn.y = pos_Y;
			objBtn.name = "Btn_" + strName;
			objParent.addChild(objBtn);
		}		
	}
}