﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.text.TextFormat;
	import flash.display.Bitmap;	
	import classes.common.Static_Value;
	import classes.common.BaseStage;
	import classes.common.BaseButton;
	import classes.common.Exercise_Text;
	
	import flash.events.TransformGestureEvent;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import fl.motion.MatrixTransformer;
	import flash.geom.Point;
	import flash.geom.Matrix;
	
	public class Menubar_Menu extends MovieClip 
	{
		private static const SCRIPT = "Script";
		private static const ABOUT_SCRIPT = "AboutUs_Script";
		private	const INDEX_WIDTH:Number = 470;
		private	const INDEX_HEIGHT:Number = 650;		
		private var m_sprBase:Sprite;
		private var m_sprParent:Sprite;
		//private var m_objDummy:Object;
		private var m_imgScale:Number;
		private var m_Index_Width:Number = INDEX_WIDTH;
		private var m_Index_Height:Number = INDEX_HEIGHT;
		
		//--------------------------------------------------------------------------
		//  Method:Main
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------		
		public function Menubar_Menu(val_sprBase:Sprite,val_sprParent:Sprite) 
		{
			this.sprBase = val_sprBase;
			this.sprParent = val_sprParent;
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get sprBase():Sprite
		{
			return m_sprBase;
		}
		public function set sprBase(val:Sprite):void
		{
			m_sprBase = val;
		}
		
		public function get sprParent():Sprite
		{
			return m_sprParent;
		}
		public function set sprParent(val:Sprite):void
		{
			m_sprParent = val;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setMenu
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	intSession		:int	--- Session 1 or 2	
		//--------------------------------------------------------------------------	
		public function setMenu():void 
		{
			const IMAGE_HOME:String = "image/common/Home.png";
			const IMAGE_US:String = "image/common/AboutUs.png";
			const IMAGE_CLOSE:String = "image/common/Close.png";
			const TEXT_ABOUT_US:String = "text/common/About_Us.txt";
			const BUTTON_NAME_HOME:String = "btn_Home";
			const BUTTON_NAME_US:String = "btn_AboutUs";
			const BUTTON_NAME_CLOSE:String = "btn_Close";
			const BUTTON_URL_HOME:String = "Main.swf";
			const BUTTON_BASE_POS_X:Number = 205;
			const BUTTON_BASE_POS_Y:Number = 100;
			const BUTTON_BASE_HEIGHT:Number = 80;
			const BUTTON_BASE_WIDTH:Number = 200;
			const BUTTON_BASE_WIDTH_2:Number = 430;
			const BUTTON_DISTANCE_X:Number = 20;
			const BUTTON_DISTANCE_Y:Number = 20;
			const BUTTON_ADJUST_Y:Number = 30;
			const SCRIPT_WIDTH:Number = 600;
			
			/**	Set Buttons	**/
			var objScript:Object;
			var btnObject:BaseButton;			

			//Button Home
			var btn_home:BaseButton = setButtonImage(IMAGE_HOME,BUTTON_NAME_HOME,BUTTON_BASE_POS_X
													 ,BUTTON_BASE_POS_Y,1.0,BUTTON_URL_HOME,null);
			//-- Button About us -- //
			if(TEXT_ABOUT_US!="")
			{	//Set Script 
				objScript = setScript(TEXT_ABOUT_US,ABOUT_SCRIPT,SCRIPT_WIDTH,400);
				// Set button
				var btn_us:BaseButton = setButtonImage(IMAGE_US,BUTTON_NAME_US,BUTTON_BASE_POS_X
														 ,BUTTON_BASE_POS_Y + BUTTON_BASE_HEIGHT + BUTTON_DISTANCE_Y + BUTTON_ADJUST_Y,1.0,"",objScript);			
			}
//			if(TEXT_ABOUT_US!="")
//			{	//Set Script 
//				objScript = setScript(TEXT_ABOUT_US,ABOUT_SCRIPT,SCRIPT_WIDTH,400);
//				// Set button
//				btnObject = new BaseButton("About US");
//				btnObject.textButton("ﺣﻮل اﻟﺘﻄﺒﻴﻖ",BUTTON_BASE_WIDTH_2,BUTTON_BASE_HEIGHT);			
//				btnObject.x = BUTTON_BASE_POS_X;
//				btnObject.y = BUTTON_BASE_POS_Y + BUTTON_BASE_HEIGHT + BUTTON_DISTANCE_Y + BUTTON_ADJUST_Y;	//(350)
//				btnObject.removeEventListener(MouseEvent.CLICK,mouseClick("",objScript));
//				btnObject.addEventListener(MouseEvent.CLICK,mouseClick("",objScript));
//				sprParent.addChild(btnObject);
//			}
			//Button Close
			var btn_close:BaseButton = setButtonImage(IMAGE_CLOSE,BUTTON_NAME_CLOSE,BUTTON_BASE_POS_X
													 ,BUTTON_BASE_POS_Y + BUTTON_BASE_HEIGHT * 2 + BUTTON_DISTANCE_Y * 2 + BUTTON_ADJUST_Y,1.0,BUTTON_URL_HOME,null);			
			btn_close.removeEventListener(MouseEvent.CLICK,closeClick);
			btn_close.addEventListener(MouseEvent.CLICK,closeClick);

//			var btn_Close:BaseButton = new BaseButton("Close");
//			btn_Close.textButton("ﺧﺮوج",BUTTON_BASE_WIDTH_2,BUTTON_BASE_HEIGHT);			
//			btn_Close.x = BUTTON_BASE_POS_X;
//			btn_Close.y = BUTTON_BASE_POS_Y + BUTTON_BASE_HEIGHT * 2 + BUTTON_DISTANCE_Y * 2 + BUTTON_ADJUST_Y;	//(550);
//			btn_Close.removeEventListener(MouseEvent.CLICK,closeClick);
//			btn_Close.addEventListener(MouseEvent.CLICK,closeClick);
//			sprParent.addChild(btn_Close);			
			///**Menu Bar**///
			//objBase.create_menubar("Menu Session",20,"Main.swf",true);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setButtonImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Display text
		//				strImgName		:String	--- Font Type
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//				strRtnURL		:String	--- Return URL
		//				objScript		:Object	--- Display Object		
		//--------------------------------------------------------------------------	
		private function setButtonImage(strImgURL:String,strImgName:String,pos_X:Number
										,pos_Y:Number,numScale:Number,strRtnURL:String
										,objScript:Object):BaseButton 
		{
			var sprBtn:BaseButton = new BaseButton(strImgName);
			sprBtn.imageButton(strImgURL,numScale);
			sprBtn.x = pos_X;
			sprBtn.y = pos_Y;
			sprBtn.name = strImgName;
			if(strRtnURL!="" || objScript!=null)
			{ trace("setButtonImage");
				sprBtn.removeEventListener(MouseEvent.CLICK,mouseClick(strRtnURL,objScript));
				sprBtn.addEventListener(MouseEvent.CLICK,mouseClick(strRtnURL,objScript));
			}
			sprParent.addChild(sprBtn);
			return sprBtn;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setLoadImage
		//  Expranation: Load the image and set the button
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//				mouse_event		:String	--- Mouse event
		//				event_function	:Function	--- Mouse event function		
		//--------------------------------------------------------------------------	
		private function setLoadImage(strImgURL:String,strName:String
									 ,pos_X:Number,pos_Y:Number,numScale:Number
									 ,blnVisible:Boolean,blnEnabled:Boolean,mouse_event:String
									 ,event_function:Function):MovieClip
		{
			var sprImg:MovieClip = new MovieClip();
			var loader_Image:Loader = new Loader();
			var request_Image:URLRequest = new URLRequest(strImgURL);
			m_imgScale = numScale;
			sprImg.x = pos_X;
			sprImg.y = pos_Y;
			sprImg.name = strName;
			sprImg.buttonMode = true;
			loader_Image.contentLoaderInfo.addEventListener(Event.COMPLETE,imgSmoothing);
			loader_Image.scaleX = loader_Image.scaleY = numScale;
			loader_Image.name = "loader_Image" + strName;
			loader_Image.mouseEnabled = false;
			sprImg.addChild(loader_Image);
			if(mouse_event!=""){sprImg.addEventListener(mouse_event,event_function)};
			//m_objDummy = loader_Image;	//dummy
			loader_Image.load(request_Image);
			sprImg.visible = blnVisible;
			sprImg.mouseEnabled = blnEnabled;
			return sprImg;
		}

		//--------------------------------------------------------------------------
		//  Method:imgSmoothing
		//  Expranation: Smoothing of the load image(Keep the quarity)
		//	Parameter: 	event		:Event
		//--------------------------------------------------------------------------
		private function imgSmoothing(event:Event):void 
		{
			Bitmap(event.target.content).smoothing = true;
			var objTarget = event.target;
			if(m_imgScale!=0)
			{
				m_Index_Width = objTarget.content.width * m_imgScale;
				m_Index_Height = objTarget.content.height * m_imgScale;
			}
			else
			{
				m_Index_Width = objTarget.content.width;
				m_Index_Height = objTarget.content.height;
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:setScript
		//  Expranation: Setting for script
		//	Parameter: 	strImgURL		:String	--- Display text
		//				strImgName		:String	--- Font Type
		//				numTxt_Width	:Number	--- Position X
		//				numTxt_Height	:Number	--- Position Y
		//--------------------------------------------------------------------------	
		private function setScript(strTxtURL:String,strScriptName:String,numTxt_Width:Number
								   ,numTxt_Height:Number):Object 
		{	
			const SCRIPT_TEXTCOLOR:int = 0x425F9C;
			//import text			
			if(strTxtURL!="")
			{
				var objText = new Exercise_Text(sprBase,sprParent);
				var txtFormat:TextFormat = new TextFormat;
				txtFormat.font = "Times New Roman";
				txtFormat.size = 24;
				objText.setExercise_Make(strTxtURL,"",strScriptName
										 ,txtFormat,0,0
										 ,numTxt_Width,numTxt_Height,0);
			}
			//Basic setting
			var objScript = objText.objScript;
			objScript.x = (sprBase.width - objScript.width)/2;
			objScript.y = 0;
			objScript.name = strScriptName;
			objScript.visible = false;
			//Button Close
			var tmp_W:Number = objScript.width;
			var tmp_H:Number = objScript.height;
			var btnClose:BaseButton = new BaseButton("Close");
			btnClose.textButton("Close",70,30,true,20,Static_Value.FONT_TYPE_BASE);
			btnClose.x = tmp_W - 120;
			btnClose.y = tmp_H - 50;
			btnClose.name = "Btn_close";
			btnClose.removeEventListener(MouseEvent.CLICK,closeScriptClick(objScript));
			btnClose.addEventListener(MouseEvent.CLICK,closeScriptClick(objScript));
			objScript.addChild(btnClose);
			//Add script in Sprite
			sprParent.addChild(objScript);
			return objScript;
		}
	
		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouseClick　event
		//	Parameter: 	strURL	:String	--- Move to URL after click
		//--------------------------------------------------------------------------
		private function closeScriptClick(objScript:Object):Function{
			return function(event:Event):void{
				if(objScript!=null){objScript.visible = false;}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:getScript
		//  Expranation: Get Sound Script
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------
		private function showScript(strTargetName:String):void 
		{
			var strName:String = "";
			var objScript;
   			for(var i:int=0; i<sprParent.numChildren; i++)
			{
				strName = sprParent.getChildAt(i).name;
				if(strName.indexOf(SCRIPT,0)!=-1)
				{
					sprParent.getChildAt(i).visible = false;
				}				
				if(sprParent.getChildAt(i).name==strTargetName)
				{
					objScript = sprParent.getChildAt(i);
					objScript.x = sprParent.width/2 - objScript.width/2;
					objScript.y = Static_Value.INSTRACTOR_BASE_Y;
					//sprParent.setChildIndex(MovieClip(objScript),sprParent.numChildren-1);	//move front
					sprParent.setChildIndex(objScript,sprParent.numChildren-1);	//move front
					objScript.visible = true;
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouseClick　event
		//	Parameter: 	strURL	:String	--- Move to URL after click
		//--------------------------------------------------------------------------
		private function mouseClick(strURL:String,objScript:Object):Function{
			return function(event:Event):void{
				if(strURL!="")
				{
					var objRequest:URLRequest = new URLRequest(strURL);
					var objLoader:Loader = new Loader();
					objLoader.load(objRequest);
					while(sprBase.numChildren > 0){
							//trace("sprBase.getChildAt(0).name;" + sprBase.getChildAt(0).name);
							sprBase.removeChildAt(0);  
					}
					sprBase.addChild(objLoader);
				}else if(objScript!=null)
				{
					showScript(objScript.name);
				}
			}
		}
	
		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouseClick　event
		//	Parameter: 	strURL	:String	--- Move to URL after click
		//--------------------------------------------------------------------------
		private function closeClick(event:Event):void
		{
			sprParent.visible = false;
		}		
	}
}