﻿package classes.vocabulary.Unit_01_Number 
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import classes.common.Static_Value;
	import classes.common.BaseStage;
	
	public class Unit_01_Number extends MovieClip 
	{
		var m_objBase:BaseStage = new BaseStage();
		
		//--------------------------------------------------------------------------
		//  Method:Main
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------		
		public function Unit_01_Number() 
		{
			init();
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}

		//--------------------------------------------------------------------------
		//  Method:init
		//  Expranation: Initialize for objects
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------
		private function init():void
		{
			/** Main Container**/
			this.addChild(objBase.sprMain);
			///**Menu Bar**///
			objBase.create_menubar("",Static_Value.MENUBAR_TTL_L,"VocabularySession.swf",true);
			/**	Instructor	**/
			objBase.create_instructor(null,0,0,null,0,0);
			///** Exercise Area**///
			objBase.create_exercise(Static_Value.EXERCISE_NORMAL_X,Static_Value.EXERCISE_NORMAL_Y);	//Create objBase.sprExercise
			///** Setting Categories **///
			createExercise();
//			///** Footer **///
//			objBase.create_footer_activities("Activity",null,Static_Value.FOOTER_BTNACT_3_BASE_X);
//			objBase.sprFooter.visible = false;
		}
		
		//--------------------------------------------------------------------------
		//  Method:createExercise
		//  Expranation: Create Exercise
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------	
		private function createExercise():void
		{
			var objSection = new Unit_01_Number_Section();
			objSection.name = Static_Value.UNIT_01_NUMBER_SECTION;
			objSection.objBase = objBase;
			objSection.init();
			objBase.sprExercise.addChild(objSection);
		}		
	}
}