﻿package classes.vocabulary.Unit_05_Animal
{
	import flash.display.Sprite;
	import flash.display.MovieClip;	
	import classes.common.BaseStage;
	import classes.common.Static_Value;	
	import classes.common.Exercise_Vocabulary;

	public class Unit_05_Animal_Act_1 extends MovieClip 
	{
		var m_objBase:BaseStage;
		
		//--------------------------------------------------------------------------
		//  Method:Unit_05_Animal_Act_1
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------
		public function Unit_05_Animal_Act_1() 
		{
			//init();
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}
		
		//--------------------------------------------------------------------------
		//  Method:init
		//  Expranation: Initialize
		//	Parameter: 	---  		
		//--------------------------------------------------------------------------	
		public function init():void
		{
			objBase.replace_menubar("",Static_Value.MENUBAR_TTL_VS,"",Static_Value.UNIT_05_ANIMAL_VOC,Unit_05_Animal_Section);
			///** Exercise **///
			objBase.sprExercise.y = Static_Value.EXERCISE_NORMAL_Y;
			///** Setting ContainerItems **///
			setExercise();
		}

		//--------------------------------------------------------------------------
		//  Method:setExercise
		//  Expranation: Create Exercise
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------	
		private function setExercise():void
		{
			var objExercise_Voc:Exercise_Vocabulary = new Exercise_Vocabulary(objBase.sprMain,objBase.sprExercise);
			//* setContainerItems *//
			var aryItems_Mov:Array = [V_1_1_item_00,V_1_1_item_01,V_1_1_item_02,V_1_1_item_03
									  ,V_1_1_item_04,V_1_1_item_05];
			var aryItems_LargeMov:Array = [V_1_L1_item_00,V_1_L1_item_01,V_1_L1_item_02,V_1_L1_item_03
									  ,V_1_L1_item_04,V_1_L1_item_05];
			var aryItems_Txt:Array = [V_1_1_txt_00,V_1_1_txt_01,V_1_1_txt_02,V_1_1_txt_03
									  ,V_1_1_txt_04,V_1_1_txt_05];			
			var aryItems_Nam:Array = ["elephant","cat","sheep","cow"
									  ,"zebra","camel"];
			var aryItems_Snd:Array = [Sound_elephant,Sound_cat,Sound_sheep,Sound_cow
									  ,Sound_zebra,Sound_camel];		
			//* setVocabulary Activity 1 *//
			objExercise_Voc.setExercise_Act1(aryItems_Mov.length/2,aryItems_Mov,aryItems_LargeMov
											 ,aryItems_Txt,aryItems_Nam,aryItems_Snd
											 ,Select_150,Static_Value.VOC_ITEM_6PIC_BASE_POS_X,Static_Value.VOC_ITEM_6PIC_BASE_POS_Y_ACT_1
											 ,Static_Value.ITEM_SIZE_6PIC,Static_Value.ITEM_DISTANCE_6PIC_X,Static_Value.ITEM_DISTANCE_6PIC_Y);
		}
	}	
}
