﻿package classes.vocabulary.Unit_06_Vehicle 
{
	import flash.display.Sprite;
	import flash.display.MovieClip;	
	import classes.common.BaseStage;
	import classes.common.Static_Value;
	import classes.common.Exercise_Vocabulary;

	public class Unit_06_Vehicle_Act_2 extends MovieClip 
	{	
		var m_objBase:BaseStage;
		
		//--------------------------------------------------------------------------
		//  Method:Unit_06_Vehicle_Act_2
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------
		public function Unit_06_Vehicle_Act_2() 
		{
			//init();
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}
	
		//--------------------------------------------------------------------------
		//  Method:init
		//  Expranation: Initialize
		//	Parameter: 	---  		
		//--------------------------------------------------------------------------	
		public function init():void
		{
			objBase.replace_menubar("",Static_Value.MENUBAR_TTL_VS,"",Static_Value.UNIT_06_VEHICLE_VOC,Unit_06_Vehicle_Section);
			//* Exercise *//
			objBase.sprExercise.y = Static_Value.EXERCISE_NORMAL_Y;
			//* Setting ContainerItems *//
			setExercise();
		}

		//--------------------------------------------------------------------------
		//  Method:setExercise
		//  Expranation: Create Exercise
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------	
		private function setExercise():void
		{
			var objExercise_Voc:Exercise_Vocabulary = new Exercise_Vocabulary(objBase.sprMain,objBase.sprExercise);
			objExercise_Voc.objInstructor.setBasicInstructor_Response();
			// setContainerItems //
			var aryItems_Mov:Array = [V_1_1_item_00,V_1_1_item_01,V_1_1_item_02,V_1_1_item_03
									  ,V_1_1_item_04,V_1_1_item_05];
			var aryItems_LargeMov:Array = [V_1_L1_item_00,V_1_L1_item_01,V_1_L1_item_02,V_1_L1_item_03
									  		,V_1_L1_item_04,V_1_L1_item_05];
			var aryItems_Nam:Array = ["car","bus","bicycle","airplane"
									  ,"train","ship"];
			var aryQuize_Txt:Array = [V_1_1_txt_04,V_1_1_txt_00,V_1_1_txt_03,V_1_1_txt_05
									  ,V_1_1_txt_02,V_1_1_txt_01];
			var aryQuize_Snd:Array = [Sound_train,Sound_car,Sound_airplane,Sound_ship
									  ,Sound_bicycle,Sound_bus];  
			var aryQuize_Ans:Array = ["train","car","airplane","ship"
									  ,"bicycle","bus"];	
			// setVocabulary Activity 2 //
			objExercise_Voc.setExercise_Act2(aryItems_Mov.length,aryItems_Mov,aryItems_LargeMov
											,aryItems_Nam,aryQuize_Txt,aryQuize_Snd
											,aryQuize_Ans,null,Static_Value.VOC_ITEM_6PIC_BASE_POS_X
											,Static_Value.VOC_ITEM_6PIC_BASE_POS_Y_ACT_2,Static_Value.VOC_TEXTBOX_6PIC_BASE_POS_X,Static_Value.VOC_TEXTBOX_BASE_POS_Y
											,Static_Value.ITEM_DISTANCE_6PIC_X,Static_Value.ITEM_DISTANCE_6PIC_Y,Static_Value.SPEAKER_IMAGE_32
											,Static_Value.VOC_TEXTBOX_6PIC_BASE_POS_X,Static_Value.VOC_SPEAKER_BASE_POS_Y);
		}
	}	
}