﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.utils.Dictionary;	
	import classes.common.BaseStage;
	import classes.common.Static_Value;	
	import classes.common.Exercise;
	import classes.common.Exercise_DragAndDrop;
	
	public class Exercise_Puzzle extends Exercise
	{		
		private var m_objBase:BaseStage;
		private var m_arySprItems:Array = new Array();
		private var m_aryExercise:Array = new Array();
		private var m_aryExercise_Ans:Array = new Array();

		//--------------------------------------------------------------------------
		//  Method:Exercise_Puzzle
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function Exercise_Puzzle(objBase:BaseStage)
		{
			m_objBase = objBase;
			super(objBase.sprMain,objBase.sprExercise);
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------

		//--------------------------------------------------------------------------
		//  Method:setBasicSetting
		//  Expranation: Setting for Basic
		//	Parameter: 	intPage			:int 	--- page No
		//				objPanels		:Object --- Exercise panel
		//--------------------------------------------------------------------------
		private function setBasicSetting(intPage:int,objPanels:Object):Object
		{
			// Basic setting //
			var objPanel = objPanels;			
			m_arySprItems[intPage] = new Sprite;
			m_arySprItems[intPage].addChild(objPanel);	
			super.sprParent.addChild(m_arySprItems[intPage]);
			m_arySprItems[intPage].name = "Exercise_" + (intPage + 1).toString();
			m_arySprItems[intPage].x = (super.sprBase.width - objPanel.width)/2; 
			m_arySprItems[intPage].y = 0;				
			if(intPage==0){m_arySprItems[intPage].visible = true;}	//The first page
			if(intPage!=0){m_arySprItems[intPage].visible = false;}
			return objPanel;
		}

		//--------------------------------------------------------------------------
		//  methods:setExercise_DragAndDrop
		//  Expranation: To set  each excercise
		//	Parameter: 	objPanel		:Object	--- Item's Movieclip
		//--------------------------------------------------------------------------
		public function setExercise_DragAndDrop(objPanel:Object,valBack:Object):void
		{
			//* Set items *//
			setContainerItems_DragAndDrop(objPanel,valBack);
		}

		//--------------------------------------------------------------------------
		//  Method:setContainerItems_DragAndDrop
		//  Expranation: Setting for the containers of the jobs
		//	Parameter: 	aryPanel		:Array	--- Item's Movieclip
		//				aryDic			:Array	--- Item's Answer
		//--------------------------------------------------------------------------
		private function setContainerItems_DragAndDrop(valPanel:Object,valBack:Object):void
		{
			/** Set Exercise **/
			// Basic setting //
			var intPage:int = 0;
			var objPanel = new valPanel;
			m_arySprItems[intPage] = new Sprite;
			m_arySprItems[intPage].addChild(objPanel);	
			super.sprParent.addChild(m_arySprItems[intPage]);
			m_arySprItems[intPage].name = "Exercise_" + (intPage + 1).toString();
			m_arySprItems[intPage].x = (super.sprBase.width - objPanel.width)/2; 
			m_arySprItems[intPage].y = 0;
			// Objects setting //
			m_aryExercise[intPage] = new Exercise_DragAndDrop(super.sprBase,objPanel);
			//m_aryExercise[intPage].objInstructor.setBasicInstructor_Response();
			m_aryExercise_Ans[intPage] = new Array();
			var obj:Object;
			var dicVal = new Dictionary ();
			for(var intObj:int=0; intObj<objPanel.numChildren; intObj++)
			{
				var strName:String = objPanel.getChildAt(intObj).name;
				if(strName.indexOf("A_")!=-1)
				{
					var intVal:int = int(strName.substr("A_".length,strName.length - "A_".length));
					obj = objPanel.getChildAt(intObj);
					// --- Set Dictionary answers ---//
					dicVal[obj] = objPanel.getChildByName("B_" + intVal);
					super.intCntQuestion = super.intCntQuestion + 1;
				}
			}
			m_aryExercise_Ans[intPage] = dicVal;
			m_aryExercise[intPage].setExercise(1,"DragAndDrop",dicVal);
			///**Menu Bar**///
			m_objBase.create_menubar("",Static_Value.MENUBAR_TTL_L,"Puzzle.swf",true);
		}
	}
}