﻿package classes.emotion
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;	
	import classes.common.BaseStage;
	import classes.common.BaseButton;
	import classes.common.Exercise_Emotion;
	import classes.common.Menubar_Menu;
	import classes.common.Static_Value;
	import classes.common.CommonFunction;
	
	public class Start extends MovieClip 
	{
		//--------------------------------------------------------------------------
		//  member variable
		//--------------------------------------------------------------------------
		private const START_IMG:String = "image/common/Emotion_Start.png";
		private var m_objBase:BaseStage;
		private var m_sprMenuDisplay:Sprite;
	
		//--------------------------------------------------------------------------
		//  Method:Start
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------		
		public function Start(valBase:BaseStage) 
		{
			objBase = valBase;
			init();
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}

		//--------------------------------------------------------------------------
		//  Method:init
		//  Expranation: Initialize for objects
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------
		private function init():void
		{
			const BUTTON_NAME:String = "Start";
			const BUTTON_BASE_X:Number = 600;
			const BUTTON_BASE_Y:Number = 150;
			/**	Set Buttons	**/
			var strName:String = "";
			var pos_X:Number = 0;
			var pos_Y:Number = 0; 
			/* Start */
			//var aryPuzzle:Array = [emotion];
			//strName = "";
			pos_X = BUTTON_BASE_X;
			pos_Y = BUTTON_BASE_Y;
			set_Image_button(START_IMG,BUTTON_NAME,pos_X
							 ,pos_Y,mouseClick,emotion); 
			/* Instruction */
			var objCmnFnc:CommonFunction = new CommonFunction();
			objCmnFnc.set_Instruction_button(objBase,this,Static_Value.INST_BUTTON_IMAGE
											 ,Static_Value.INSTRACTOR_NAME + "_Emotion",Static_Value.INST_BUTTON_BASE_X,Static_Value.INST_BUTTON_BASE_Y
											 ,Instruction_emotion); 
		}
		
		//--------------------------------------------------------------------------
		//  Method:set_Image_button
		//  Expranation: Setting for Instruction Button
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		private function set_Image_button(img_URL:String,strName:String,pos_X:Number
										  ,pos_Y:Number,fnc_Click:Function,objMov:Object):void 
		{
			var objBtn:BaseButton = new BaseButton(strName);
			objBtn.imageButton(img_URL,1.0);
			objBtn.x = pos_X;
			objBtn.y = pos_Y;
			objBtn.name = "Btn_" + strName;
			objBtn.removeEventListener(MouseEvent.CLICK,fnc_Click(objMov));
			objBtn.addEventListener(MouseEvent.CLICK,fnc_Click(objMov));
			//sprParent.addChild(btnPrevious);
			this.addChild(objBtn);
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouseClick　event
		//	Parameter: 	objVal	:Object	--- Move to new puzzle after click
		//--------------------------------------------------------------------------
		private function mouseClick(objVal:Object):Function{
			return function(event:Event):void{
				for(var i:int=0;i<objBase.sprMain.numChildren; i++)
				{
						//trace(objBase.sprMain.getChildAt(i).name);
						if(objBase.sprMain.getChildAt(i).name.indexOf("Exercise")!=-1)
						{
							objBase.sprMain.removeChildAt(i);
							break;
						}  
				}
				objBase.create_exercise();
				var objEmotion:Exercise_Emotion = new Exercise_Emotion(objBase);
				objEmotion.setExercise_DragAndDrop(objVal,Static_Value.RESET_BUTTON_IMAGE,Static_Value.RESET_BUTTON_BASE_X
													,Static_Value.RESET_BUTTON_BASE_Y);
			}
		}
	}	
}
