﻿package classes.puzzle
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;	
	import classes.common.BaseStage;
	import classes.common.BaseButton;
	import classes.common.Exercise_Puzzle;
	import classes.common.Static_Value;
	import classes.common.CommonFunction;
	
	public class Start extends MovieClip 
	{
		//--------------------------------------------------------------------------
		//  member variable
		//--------------------------------------------------------------------------
		private var m_objBase:BaseStage;
		private var m_sprMenuDisplay:Sprite;
	
		//--------------------------------------------------------------------------
		//  Method:Start
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------		
		public function Start(valBase:BaseStage) 
		{
			objBase = valBase;
			init();
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}

		//--------------------------------------------------------------------------
		//  Method:init
		//  Expranation: Initialize for objects
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------
		private function init():void
		{
			const BUTTON_NAME:String = "Puzzle_";//" لعبة مركبة";//
			const BUTTON_BASE_X:Number = 70;
			const BUTTON_BASE_Y:Number = 100;
			/**	Set Buttons	**/
			var strName:String = "";
			var pos_X:Number = 0;
			var pos_Y:Number = 0;
			/* Puzzles */
			var aryPuzzle:Array = [Puzzle_5,Puzzle_7,Puzzle_8,Puzzle_6,Puzzle_1,Puzzle_2,Puzzle_3,Puzzle_4];
			var aryBtnURL:Array = ["image/puzzle/buttons/Puzzle_5.png","image/puzzle/buttons/Puzzle_7.png","image/puzzle/buttons/Puzzle_8.png"
								   ,"image/puzzle/buttons/Puzzle_6.png","image/puzzle/buttons/Puzzle_1.png","image/puzzle/buttons/Puzzle_2.png"
								   ,"image/puzzle/buttons/Puzzle_3.png","image/puzzle/buttons/Puzzle_4.png"];
			strName = "";
			pos_X = BUTTON_BASE_X;
			pos_Y = 50;
			var j:int = 0;
			for(var i:uint=0;i<aryPuzzle.length;i++)
			{	
				strName = BUTTON_NAME + (i + 1);
				if(i==4){pos_X = 350;j = 0;}
				pos_Y = BUTTON_BASE_Y + j * 90;
				set_puzzle_button(strName,aryBtnURL[i],aryPuzzle[i],pos_X,pos_Y);
				j = j + 1;
			}
			/* Instruction */
			var objCmnFnc:CommonFunction = new CommonFunction();
			objCmnFnc.set_Instruction_button(objBase,this,Static_Value.INST_BUTTON_IMAGE
											 ,Static_Value.INSTRACTOR_NAME + "_Puzzle",Static_Value.INST_BUTTON_BASE_X,Static_Value.INST_BUTTON_BASE_Y
											 ,Instruction_puzzle);			
		}
		
		//--------------------------------------------------------------------------
		//  Method:set_puzzle_button
		//  Expranation: Setting for puzzle buttons
		//	Parameter: 	strBtnName	:String	--- Button name 
		//			 	strBtnURL	:String	--- Button URL
		//			 	objPuzzle	:Object	--- Puzzle object after click
		//				pos_X		:Number	--- Button X position 
		//			 	pos_Y		:Number	--- Button Y position
		//--------------------------------------------------------------------------
		private function set_puzzle_button(strBtnName:String,strBtnURL:String,objPuzzle:Object,pos_X:Number
										   ,pos_Y:Number):void
		{
			/**	Set Buttons	**/
			var objCmnFnc:CommonFunction = new CommonFunction();
			//* Exercise *//
			var obBtn:BaseButton = new BaseButton(strBtnName);
			obBtn.imageButton(strBtnURL,1.0);
			objCmnFnc.set_Image_button(obBtn,strBtnName,pos_X
							 			,pos_Y,mouseClick(objPuzzle),this);
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouseClick　event
		//	Parameter: 	objVal	:Object	--- Move to new puzzle after click
		//--------------------------------------------------------------------------
		private function mouseClick(objVal:Object):Function{
			return function(event:Event):void{
				for(var i:int=0;i<objBase.sprMain.numChildren; i++)
				{
						//trace(objBase.sprMain.getChildAt(i).name);
						if(objBase.sprMain.getChildAt(i).name.indexOf("Exercise")!=-1)
						{
							objBase.sprMain.removeChildAt(i);
							break;
						}  
				}
				objBase.create_exercise();
				var objPuzzle:Exercise_Puzzle = new Exercise_Puzzle(objBase);
				objPuzzle.setExercise_DragAndDrop(objVal,Start);
			}
		}
	}	
}
